# coding: utf-8

"""
    Production API

    API exposing endpoints for managing well  and daily production.

    The version of the OpenAPI document: 1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing import Optional, Set
from typing_extensions import Self

class NetworkCompressorConstraint(BaseModel):
    """
    NetworkCompressorConstraint
    """ # noqa: E501
    xid: StrictStr = Field(description="Xecta constraint identifier")
    compressor_xid: StrictStr = Field(description="Xecta compressor identifier", alias="compressorXid")
    source_network_id: StrictStr = Field(description="Source ID of Network Compressor Definition", alias="sourceNetworkId")
    source_compressor_id: StrictStr = Field(description="Source ID of Network Compressor Definition", alias="sourceCompressorId")
    source_id: StrictStr = Field(description="Source ID for the compressor/date constraint. This sourceID enables upsert functionality from client source systems of record", alias="sourceId")
    var_date: datetime = Field(description="Date at which the constraint becomes applicable. Datetime offset (with timezone) in ISO 8601 format. Example: 2022-09-27T16:28:37+0000", alias="date")
    max_gas_lift_injection_rate: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Maximum gas lift injection rate constraint, Mscf/d", alias="maxGasLiftInjectionRate")
    max_gas_lift_injection_pressure: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="Maximum gas lift injection pressure constraint, psig", alias="maxGasLiftInjectionPressure")
    __properties: ClassVar[List[str]] = ["xid", "compressorXid", "sourceNetworkId", "sourceCompressorId", "sourceId", "date", "maxGasLiftInjectionRate", "maxGasLiftInjectionPressure"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of NetworkCompressorConstraint from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if max_gas_lift_injection_rate (nullable) is None
        # and model_fields_set contains the field
        if self.max_gas_lift_injection_rate is None and "max_gas_lift_injection_rate" in self.model_fields_set:
            _dict['maxGasLiftInjectionRate'] = None

        # set to None if max_gas_lift_injection_pressure (nullable) is None
        # and model_fields_set contains the field
        if self.max_gas_lift_injection_pressure is None and "max_gas_lift_injection_pressure" in self.model_fields_set:
            _dict['maxGasLiftInjectionPressure'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of NetworkCompressorConstraint from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "xid": obj.get("xid"),
            "compressorXid": obj.get("compressorXid"),
            "sourceNetworkId": obj.get("sourceNetworkId"),
            "sourceCompressorId": obj.get("sourceCompressorId"),
            "sourceId": obj.get("sourceId"),
            "date": obj.get("date"),
            "maxGasLiftInjectionRate": obj.get("maxGasLiftInjectionRate"),
            "maxGasLiftInjectionPressure": obj.get("maxGasLiftInjectionPressure")
        })
        return _obj


