# coding: utf-8

"""
    Production API

    API exposing endpoints for managing well  and daily production.

    The version of the OpenAPI document: 1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictBool
from typing import Any, ClassVar, Dict, List
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class NetworkCompressorInput(BaseModel):
    """
    NetworkCompressorInput
    """ # noqa: E501
    source_network_id: Annotated[str, Field(strict=True, max_length=100)] = Field(description="SourceNetworkId the compressor belongs to", alias="sourceNetworkId")
    source_id: Annotated[str, Field(strict=True, max_length=100)] = Field(description="Source ID for the compressor definition. This sourceID enables upsert functionality from client source systems of record", alias="sourceId")
    var_date: datetime = Field(description="Date at which the compressor becomes part of the network. Datetime offset (with timezone) in ISO 8601 format. Example: 2022-09-27T16:28:37+0000", alias="date")
    upstream_source_id: Annotated[str, Field(strict=True, max_length=255)] = Field(description="Network element upstream of the compressor", alias="upstreamSourceId")
    downstream_source_id: Annotated[str, Field(strict=True, max_length=255)] = Field(description="Network element downstream of the compressor", alias="downstreamSourceId")
    enabled: StrictBool = Field(description="Whether the compressor should participate in the network (false would be the equivalent of a mask in GAP)")
    __properties: ClassVar[List[str]] = ["sourceNetworkId", "sourceId", "date", "upstreamSourceId", "downstreamSourceId", "enabled"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of NetworkCompressorInput from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of NetworkCompressorInput from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "sourceNetworkId": obj.get("sourceNetworkId"),
            "sourceId": obj.get("sourceId"),
            "date": obj.get("date"),
            "upstreamSourceId": obj.get("upstreamSourceId"),
            "downstreamSourceId": obj.get("downstreamSourceId"),
            "enabled": obj.get("enabled")
        })
        return _obj


