# coding: utf-8

"""
    Production API

    API exposing endpoints for managing well  and daily production.

    The version of the OpenAPI document: 1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing import Optional, Set
from typing_extensions import Self

class Tubing(BaseModel):
    """
    Tubing
    """ # noqa: E501
    xid: StrictStr
    source_id: StrictStr = Field(alias="sourceId")
    top_md: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, alias="topMd")
    bottom_md: Union[StrictFloat, StrictInt] = Field(alias="bottomMd")
    id: Union[StrictFloat, StrictInt]
    od: Union[StrictFloat, StrictInt]
    roughness: Optional[Union[StrictFloat, StrictInt]] = None
    run_date: Optional[datetime] = Field(default=None, alias="runDate")
    pull_date: Optional[datetime] = Field(default=None, alias="pullDate")
    __properties: ClassVar[List[str]] = ["xid", "sourceId", "topMd", "bottomMd", "id", "od", "roughness", "runDate", "pullDate"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Tubing from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if top_md (nullable) is None
        # and model_fields_set contains the field
        if self.top_md is None and "top_md" in self.model_fields_set:
            _dict['topMd'] = None

        # set to None if roughness (nullable) is None
        # and model_fields_set contains the field
        if self.roughness is None and "roughness" in self.model_fields_set:
            _dict['roughness'] = None

        # set to None if run_date (nullable) is None
        # and model_fields_set contains the field
        if self.run_date is None and "run_date" in self.model_fields_set:
            _dict['runDate'] = None

        # set to None if pull_date (nullable) is None
        # and model_fields_set contains the field
        if self.pull_date is None and "pull_date" in self.model_fields_set:
            _dict['pullDate'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Tubing from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "xid": obj.get("xid"),
            "sourceId": obj.get("sourceId"),
            "topMd": obj.get("topMd"),
            "bottomMd": obj.get("bottomMd"),
            "id": obj.get("id"),
            "od": obj.get("od"),
            "roughness": obj.get("roughness"),
            "runDate": obj.get("runDate"),
            "pullDate": obj.get("pullDate")
        })
        return _obj


